/* eslint-disable camelcase */
const { ProvinceModel, CityModel } = require('../../../models/StateCity')
const UserModel = require('../../../models/UserModel')
const jwt = require('jsonwebtoken')

const setAddress = async (req, res, next) => {
  try {
    const token = req.header('Authorization').split(' ')[1]
    if (!token) return res.status(401).send('Access Denied')
    const { province_id, city_id, address, lat, lng, show_location } = req.body
    // اعتبارسنجی داده‌ها
    if (!province_id || !city_id || !address || !lat || !lng || show_location === 'undefined') {
      return res.status(422).json({
        error: true,
        message: 'اطلاعات ارسالی ناقص است'
      })
    }

    // یافتن کاربر با شماره موبایل
    const decodedToken = jwt.verify(token, process.env.APP_SECRET)
    const user = await UserModel.findById(decodedToken.id)
    if (!user) {
      return res.status(404).json({
        error: true,
        message: 'کاربری با این شماره موبایل یافت نشد'
      })
    }

    // یافتن استان و شهر
    const province = await ProvinceModel.findOne({ id: province_id })
    const city = await CityModel.findOne({ id: city_id })
    if (!province || !city) {
      return res.status(404).json({
        error: true,
        message: 'استان یا شهر موردنظر یافت نشد'
      })
    }

    user.province = province
    user.city = city
    user.address = address
    user.lat = lat
    user.lng = lng
    user.show_location = show_location

    await user.save()

    return res.json({
      message: 'آدرس با موفقیت به‌روزرسانی شد'
    })
  } catch (error) {
    next(error)
  }
}
const updateAddress = async (req, res, next) => {
  try {
    const token = req.header('Authorization').split(' ')[1]
    if (!token) return res.status(401).send('Access Denied')

    const { province_id, city_id, address, lat, lng, show_location } = req.body

    // اعتبارسنجی داده‌ها
    if (!province_id || !city_id || !address || !lat || !lng || show_location === undefined) {
      return res.status(422).json({
        error: true,
        message: 'اطلاعات ارسالی ناقص است'
      })
    }

    const decodedToken = jwt.verify(token, process.env.APP_SECRET)
    const userId = decodedToken.id

    // یافتن کاربر با استفاده از شناسه کاربر
    const user = await UserModel.findById(userId)
    if (!user) {
      return res.status(404).json({
        error: true,
        message: 'کاربری با این شناسه یافت نشد'
      })
    }

    // یافتن استان و شهر با استفاده از شناسه استان و شهر
    const province = await ProvinceModel.findOne({ id: province_id })
    const city = await CityModel.findOne({ id: city_id })
    if (!province || !city) {
      return res.status(404).json({
        error: true,
        message: 'استان یا شهر مورد نظر یافت نشد'
      })
    }

    // به‌روزرسانی اطلاعات آدرس کاربر
    user.province = province
    user.city = city
    user.address = address
    user.lat = lat
    user.lng = lng
    user.show_location = show_location

    await user.save()

    return res.json({
      message: 'آدرس با موفقیت به‌روزرسانی شد'
    })
  } catch (error) {
    next(error)
  }
}

module.exports = {
  setAddress, updateAddress
}
